"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _graphql = require("gatsby/graphql");

var _commonFields = require("./commonFields");

var _cloudinaryPromised = require("cloudinary-promised");

var _getSrcSet = require("./getSrcSet");

var _getResponsiveWidths = require("./getResponsiveWidths");

var _commonTags = require("common-tags");

var _promise = _interopRequireDefault(require("md5-file/promise"));

var _getBase64FromUrl = require("./get-base64-from-url");

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                    The max height the media will be displayed at.\n                    You probably want to use maxWidth instead of this.\n                "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var _default = function _default(_ref) {
  var pathPrefix = _ref.pathPrefix,
      getNodeAndSavePathDependency = _ref.getNodeAndSavePathDependency,
      reporter = _ref.reporter,
      cloudinaryConfig = _ref.cloudinaryConfig;
  return {
    type: new _graphql.GraphQLObjectType({
      name: 'ImageCloudinaryFluid',
      fields: (0, _objectSpread2.default)({}, _commonFields.commonFields, {
        sizes: {
          type: _graphql.GraphQLString
        }
      })
    }),
    args: {
      maxWidth: {
        type: _graphql.GraphQLInt,
        description: 'The max width the media will be displayed at.',
        defaultValue: 800
      },
      maxHeight: {
        type: _graphql.GraphQLInt,
        description: (0, _commonTags.oneLine)(_templateObject())
      },
      toImgFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert img to.'
      },
      toVideoFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert video to.'
      },
      toVideoPosterFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert videoPoster to.'
      }
    },
    resolve: function () {
      var _resolve = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(image, fieldArgs, context) {
        var file, path, id, data, width, maxWidth, sizes, widths, mediaData, videoPosterSrc, videoSrc, videoSrcSetImages, videoPosterSrcSet, videoPosterBase64Url, videoPosterBase64, videoPosterData, videoData, imgSrc, imgSrcSetImages, imgSrcSet, imgBase64Url, imgBase64, imgData;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                file = getNodeAndSavePathDependency(image.parent, context.path);
                path = file.absolutePath; // Use an md5 hash of the file as the ID.

                _context.next = 4;
                return (0, _promise.default)(path);

              case 4:
                id = _context.sent;
                _context.next = 7;
                return (0, _cloudinaryPromised.uploadOrGetMetadata)(id, path, cloudinaryConfig);

              case 7:
                data = _context.sent;
                width = Math.min(fieldArgs.maxWidth, data.width);
                maxWidth = fieldArgs.maxWidth;
                sizes = "(max-width: ".concat(width, "px) 100vw, ").concat(width, "px");
                widths = (0, _getResponsiveWidths.getResponsiveWidths)(maxWidth, width);

                if (!(0, _cloudinaryPromised.isVideo)(path)) {
                  _context.next = 26;
                  break;
                }

                videoPosterSrc = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(width, "/").concat(id, ".jpg");
                videoSrc = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(width, "/").concat(id, ".mp4"); // Get the srcSet.

                videoSrcSetImages = widths.map(function (w) {
                  return {
                    width: w,
                    src: "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(w, "/").concat(id, ".jpg")
                  };
                });
                videoPosterSrcSet = (0, _getSrcSet.getSrcSet)(videoSrcSetImages); // Get base64.

                videoPosterBase64Url = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_10/").concat(id, ".jpg");
                _context.next = 20;
                return (0, _getBase64FromUrl.getBase64FromUrl)(videoPosterBase64Url);

              case 20:
                videoPosterBase64 = _context.sent;
                videoPosterData = {
                  videoPosterSrc: videoPosterSrc,
                  videoPosterSrcSet: videoPosterSrcSet,
                  videoPosterBase64: videoPosterBase64
                };
                videoData = {
                  videoSrc: videoSrc
                };
                mediaData = (0, _objectSpread2.default)({}, videoPosterData, videoData);
                _context.next = 35;
                break;

              case 26:
                imgSrc = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_").concat(width, "/").concat(id); // Get the srcSet.

                imgSrcSetImages = widths.map(function (w) {
                  return {
                    width: w,
                    src: "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_").concat(w, "/").concat(id)
                  };
                });
                imgSrcSet = (0, _getSrcSet.getSrcSet)(imgSrcSetImages); // Get base64.

                imgBase64Url = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_10/").concat(id, ".jpg");
                _context.next = 32;
                return (0, _getBase64FromUrl.getBase64FromUrl)(imgBase64Url);

              case 32:
                imgBase64 = _context.sent;
                imgData = {
                  imgSrc: imgSrc,
                  imgSrcSet: imgSrcSet,
                  imgBase64: imgBase64
                };
                mediaData = (0, _objectSpread2.default)({}, imgData);

              case 35:
                return _context.abrupt("return", (0, _objectSpread2.default)({
                  // internal
                  id: id,
                  path: path,
                  maxWidth: fieldArgs.maxWidth,
                  maxHeight: fieldArgs.maxHeight,
                  // dimensions
                  width: data.width,
                  height: data.height,
                  aspectRatio: data.width / data.height
                }, mediaData, {
                  sizes: sizes
                }));

              case 36:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function resolve(_x, _x2, _x3) {
        return _resolve.apply(this, arguments);
      };
    }()
  };
};

exports.default = _default;