"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _graphql = require("gatsby/graphql");

var _fs = _interopRequireDefault(require("fs"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _probeImageSize = _interopRequireDefault(require("probe-image-size"));

var _path = _interopRequireDefault(require("path"));

function toArray(buf) {
  var arr = new Array(buf.length);

  for (var i = 0; i < buf.length; i++) {
    arr[i] = buf[i];
  }

  return arr;
}

var _default = function _default(_ref) {
  var pathPrefix = _ref.pathPrefix,
      getNodeAndSavePathDependency = _ref.getNodeAndSavePathDependency;
  return {
    args: {},
    type: new _graphql.GraphQLObjectType({
      name: 'ImageCloudinaryOriginal',
      fields: {
        width: {
          type: _graphql.GraphQLFloat
        },
        height: {
          type: _graphql.GraphQLFloat
        },
        aspectRatio: {
          type: _graphql.GraphQLFloat
        },
        src: {
          type: _graphql.GraphQLString
        }
      }
    }),
    resolve: function () {
      var _resolve = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(image, fieldArgs, context) {
        var details, dimensions, imageName, publicPath;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                details = getNodeAndSavePathDependency(image.parent, context.path);
                dimensions = _probeImageSize.default.sync(toArray(_fs.default.readFileSync(details.absolutePath)));
                imageName = "".concat(details.name, "-").concat(image.internal.contentDigest).concat(details.ext);
                publicPath = _path.default.join(process.cwd(), "public", "static", imageName);

                if (!_fsExtra.default.existsSync(publicPath)) {
                  _fsExtra.default.copy(details.absolutePath, publicPath, function (err) {
                    if (err) {
                      console.error("error copying file from ".concat(details.absolutePath, " to ").concat(publicPath), err);
                    }
                  });
                }

                return _context.abrupt("return", {
                  width: dimensions.width,
                  height: dimensions.height,
                  aspectRatio: dimensions.width / dimensions.height,
                  src: "".concat(pathPrefix, "/static/").concat(imageName)
                });

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function resolve(_x, _x2, _x3) {
        return _resolve.apply(this, arguments);
      };
    }()
  };
};

exports.default = _default;