"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.commonFields = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _gatsbyPluginSharp = require("gatsby-plugin-sharp");

var _commonTags = require("common-tags");

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            A base64 version of the poster.\n        "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            srcSet for the poster.\n        "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            src for the poster.\n        "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            src for the video.\n        "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            A base64 version of the image.\n        "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            srcSet for the image.\n        "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            src for the image.\n        "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n            The aspect ratio of the media (width/height).\n            Can be used to ensure there is space reserved for the media.\n            This can prevent page jank when the media loads.\n        "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var _require = require('gatsby/graphql'),
    GraphQLString = _require.GraphQLString,
    GraphQLFloat = _require.GraphQLFloat;

var commonFields = {
  width: {
    type: GraphQLFloat,
    description: 'The original width of the media.'
  },
  height: {
    type: GraphQLFloat,
    description: 'The original height of the media.'
  },
  aspectRatio: {
    type: GraphQLFloat,
    description: (0, _commonTags.oneLine)(_templateObject())
  },
  // ----------------------------------------
  // img
  // ----------------------------------------
  imgSrc: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject2())
  },
  imgSrcSet: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject3())
  },
  imgBase64: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject4())
  },
  // ----------------------------------------
  // video
  //
  // no srcSet or base64
  // as those do not make sense for videos
  // ----------------------------------------
  videoSrc: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject5())
  },
  // ----------------------------------------
  // videoPoster
  // ----------------------------------------
  videoPosterSrc: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject6())
  },
  videoPosterSrcSet: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject7())
  },
  videoPosterBase64: {
    type: GraphQLString,
    description: (0, _commonTags.oneLine)(_templateObject8())
  }
};
exports.commonFields = commonFields;